ChiliProject - Feature # 210: Bump redcloth version

Status: Open Priority: Normal
Author: Eric Thomas Category: Libraries
Created: 2011-02-19 Assignee:

Updated: 2011-12-11 Due date:

Remote issue URL:

Affected version:

Description: The current redcloth is very old and a lot of improvements have been made to it.
This "commit":https://github.com/et/chiliproject/commit/2b6dd536a336d223ff43f30caa492a2306537441
upgrades redcloth to the stable version (4.2.2).

| have another commit which integrates it with CodeRay, but first a question:

Blocks of code are done with @bc[ruby].. code@, see
"here":http://redcloth.org/textile/html-integration-and-escapement/#block-code.

| couldn't find any reference to @pre/code class="ruby"@ in the redcloth textile documentation. Was this
redmine specific?

Should ChiliProject support both ways of formatting code or one way (if one, which one?).

Associated revisions

2008-02-03 04:34 pm - Jean-Philippe Lang
Do not use RedCloth's glyphs (#210).

git-svn-id: http://redmine.rubyforge.org/svn/trunk@1113 e93f8b46-1217-0410-a6f0-8f06a7374b81

History

2011-02-19 11:51 am - Felix Schéfer

IIRC redcloth 4 has binary parts that aren't windows-compatible, am | mistaken?
2011-02-19 04:44 pm - Eric Thomas
Felix SchArfer wrote:

> IIRC redcloth 4 has binary parts that aren't windows-compatible, am | mistaken?

| seem to remember a response from matz to someone who remarked that the latest release of ruby didn't work on windows to which he replied

(something along these lines): "l don't use windows, so | don't care."

| wish everyone had this philosophy.

All kidding aside, according to the redcloth "homepage":http://redcloth.org/:

bg. RedCloth will compile the C extension and install. RedCloth is available for native Ruby, JRuby, and Win32 platform.

| have zero experience with running ruby on windows nor do | have access to a windows box so | really have no way of testing this. Can anybody

assist?
2011-02-19 05:26 pm - Aleksey Zapparov
If it does matter, | can check RedCloth on Windows, just tell me which version of it against which version of Ruby you want me to check, so I'll check it

on one of my WinXP boxes.

2011-02-19 05:38 pm - Eric Thomas
Aleksey, | ran it on the master branch with RedCloth 4.2.2 and ruby 1.9.2.

From what I've gathered on RedCloth's website, it looks like ruby >=1.8.6 is supported, so could you try it with ruby 1.8.7? Thanks!
2011-02-19 11:13 pm - Eric Davis
If someone can test RedCloth with Ruby 1.8.7 and 1.9.2 on Windows that would be great. | think coderay is the part that uses the @pre/code@ blocks
but | could be wrong.

2011-02-20 01:05 am - lan Freeman
It's easy to do a virtualbox vm, although | agree, who cares about hosting a website on windows? :)

2011-02-20 05:25 am - Eric Thomas
Eric Davis wrote:

> | think coderay is the part that uses the @pre/code@ blocks but | could be wrong.

It is done here:
source:lib/redmine/wiki_formatting/textile/formatter.rb#L55

Basically takes @< pre >< code class="ruby" >@ and translates it to @< pre >< code class="syntaxhl ruby" > CodeRay formatting etc. etc.@

Looking closely at the output of @bc..@, it looks like it should stay the same since when skipping a line with bc, RedCloth creates a new block.

Consider this example

<pre>

bc[ruby].. def hello_world
puts "hello world"

end

def goodbye_world
puts "goodbye world"
end

</pre>

RedCloth will create the following:

<pre>
<pre >
< code lang="ruby" >
def hello_world

puts "hello world"
end

< /code >

< code lang="ruby" >

def goodbye_world
puts "goodbye world"

end

< /code >

</ pre>

</pre>

Since there are two @< code >@ sections, it would be treated as if there are two separate code blocks which is probably not what the user intended.
| propose to not even include the @bc@ tag and just stick with the current format.

2011-02-20 05:04 pm - Felix Schafer

- Target version set to 2.0.0
Back to the original point :-) I'm OK with upgrading redcloth if it works on windows too, | think that's big enough to hold it for 2.0.0 though.

2011-03-03 01:04 pm - lan Freeman
Eric Davis wrote:

> If someone can test RedCloth with Ruby 1.8.7 and 1.9.2 on Windows that would be great.

I'm attempting to do so but | am a complete noob when it comes to rails and ruby. | can't seem to include the redcloth gem with ruby 1.8.7 on

windows/mongrel.

| get this:
> undefined local variable or method “version_requirements' for #<Rails::GemDependency:0x4b258a8>

When trying to rake gems:install or mongrel_rails start after @config.gem "RedCloth"@ and @require 'RedCloth'@ in environmet.rb of a test rails app.

I don't expect help from this forum on troubleshooting this, as it may be completely unrelated to RedCloth. But, I'll keep trying...

2011-03-03 01:12 pm - Holger Just

lan Freeman wrote:

> | get this:

> > undefined local variable or method “version_requirements' for #<Rails::GemDependency:0x4b258a8>

This errors comes from your rubygems which is too new. The version#4 release has fixes for rubygems 1.5, the current master for 1.6.0 (#251). Your

safest bet is to use a rubygems < 1.5.

2011-03-07 12:49 am - lan Freeman
gem -v says 1.5.2. | was using master current when | posted. Still try older gem?

2011-03-07 03:56 am - Eric Thomas

lan | am using version 1.6.2 on the master with no problem.

2011-03-07 06:53 pm - lan Freeman
I'm now using 1.6.1 with fewer problems. Now trying to sort out syntax errors on load calls (as reported by mongrel_rails start -e production).

You may want to reconfirm that master works with gem 1.5 (did not for me).
2011-03-07 06:56 pm - Holger Just
@lan. The current 1.1 release should work with rubygems 1.5, the current master with 1.6. If there are still bugs, please re-open #251, but don't

re-purpose other issues.

2011-03-18 05:56 pm - Eric Davis
- Target version deleted (2.0.0)

- Category changed from Text formatting to Libraries

I'm removing this from the 2.0.0 target until someone commits to upgrading it.
2011-12-03 07:00 pm - Felix Schéafer
| had nearly forgotten about that. | just gave it a spin, and tl;dr: It works, redclotch4 works on windows, mri and jruby, but we'd need to port the 2

autolinking and the highlighting rule to redcloth4.

If I understood Holger correctly, redcloth4 would also allow us to port all the custom markup to redcloth rules, those wouldn't be available to other
formatter anymore though.

I'd like us to at least consider this for 3.0 as the next time we'll be able to bump it is middle of next year.

2011-12-11 04:01 pm - Felix Schéafer

My current work is on a branch in my repo on github: https://github.com/thegcat/chiliproject/tree/feature/210/redcloth4
Status: the @Redmine::WikiFormatting:: TextileFormatterTest@ go through but for a double-escaping problem in a <notextile>@</notextile>-block, the

problem though is that the ragel implementation makes it harder to hop in in-between the built-in methods/rules, so I'm not so sure that we would
benefit much from upgrading after all.
